package main

/*
	this parses the command line arguements

	this enables command line options from other packages like 'gui' and 'log'
*/

var argv args

type args struct {
	Package   string `arg:"--package"                  help:"the package name"`
	Proto     string `arg:"--proto"                    help:"the .proto filename"`
	Mutex     bool   `arg:"--mutex"   default:"true"   help:"insert a mutex into protoc .pb.go file"`
	MutexName string `arg:"--mutex-name"               help:"use a var name for the mutex"`
	Regret    bool   `arg:"--regret"                   help:"ignore needed UUID. You will eventually regret this."`
	Delete    bool   `arg:"--delete"                   help:"use delete with copy experiment"`
	DryRun    bool   `arg:"--dry-run"                  help:"check the .proto syntax, but don't do anything"`
	GoSrc     string `arg:"--go-src"                   help:"default is ~/go/src. could be set to your go.work path"`
	GoPath    string `arg:"--gopath"                   help:"the gopath of this repo"`
	Identify  string `arg:"--identify"                 help:"identify file"`
}

func (a args) Description() string {
	return "autogenpb " + VERSION + "    Built on " + BUILDTIME + `

Auto Generate protocol buffer Sort() and Marshal() functions

go install go.wit.com/apps/autogenpb@latest

The protobuf requires a 'standard' .proto format.
See the git sources for an example .proto file.
`
}

/*
func (args) Version() string {
	return "autogenpb " + VERSION + "    Built on " + BUILDTIME
}
*/
