package main

import (
	"fmt"
	"io"
)

// generates Append()

// I like these functions the best.
func (msg *MsgName) simpleAppend(w io.Writer, FRUIT, APPLES, APPLE string) string {
	LOCK := msg.getLockname("x")

	funcdef := "func (x *" + FRUIT + ") Append(y *" + APPLE + ")"

	// log.Printf("\t\t(x %s) APPEND(%s)\n", FRUIT, APPLE)
	// append -- no check at all
	fmt.Fprintln(w, "// just a simple Append() shortcut (but still uses the mutex lock)")
	fmt.Fprintln(w, funcdef, "{")
	fmt.Fprintln(w, "	"+LOCK+".Lock()")
	fmt.Fprintln(w, "	defer "+LOCK+".Unlock()")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	x."+APPLES+" = append(x."+APPLES+", y)")
	fmt.Fprintln(w, "}")
	fmt.Fprintln(w, "")

	return funcdef
}

/* FIX THSE as Import()
func (msg *MsgName) appendUnique(w io.Writer, FRUIT, APPLES, APPLE string, COLORS []string) {
	LOCK := msg.getLockname("x")

	fmt.Fprintln(w, "// enforces "+APPLE+" is unique in "+FRUIT+"."+APPLES)
	fmt.Fprintln(w, "func (x *"+FRUIT+") AppendUnique(newP *"+APPLE+") bool {")
	fmt.Fprintln(w, "	"+LOCK+".Lock()")
	fmt.Fprintln(w, "	defer "+LOCK+".Unlock()")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	for _, p := range x."+APPLES+" {")
	for _, COLOR := range COLORS {
		fmt.Fprintln(w, "		if p."+COLOR+" == newP."+COLOR+" {")
		fmt.Fprintln(w, "			return false")
		fmt.Fprintln(w, "		}")
	}
	fmt.Fprintln(w, "	}")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	x."+APPLES+" = append(x."+APPLES+", newP)")
	fmt.Fprintln(w, "	return true")
	fmt.Fprintln(w, "}")
	fmt.Fprintln(w, "")
}

func (msg *MsgName) appendUniqueCOLOR(w io.Writer, FRUIT, APPLES, APPLE, COLOR string) {
	LOCK := msg.getLockname("x")

	fmt.Fprintln(w, "// enforces "+APPLE+"."+COLOR+" is unique in "+FRUIT+"."+APPLES)
	fmt.Fprintln(w, "func (x *"+FRUIT+") AppendUnique"+COLOR+"(newP *"+APPLE+") bool {")
	fmt.Fprintln(w, "	"+LOCK+".Lock()")
	fmt.Fprintln(w, "	defer "+LOCK+".Unlock()")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	for _, p := range x."+APPLES+" {")
	fmt.Fprintln(w, "		if p."+COLOR+" == newP."+COLOR+" {")
	fmt.Fprintln(w, "			return false")
	fmt.Fprintln(w, "		}")
	fmt.Fprintln(w, "	}")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	x."+APPLES+" = append(x."+APPLES+", newP)")
	fmt.Fprintln(w, "	return true")
	fmt.Fprintln(w, "}")
	fmt.Fprintln(w, "")
}
*/

// Unique Append. rejects Append() if value is already defined
// compares the field 'COLOR' in the STRUCT with VARNAME
// that's not the right description above, but whatever, you get the idea
func (msg *MsgName) addAppendBy(w io.Writer, STRUCT, FUNCNAME, STRUCTVAR, VARNAME, VARTYPE string) string {
	LOCK := msg.getLockname("x")

	funcdef := "func (x *" + STRUCT + ") " + FUNCNAME + "(y *" + VARTYPE + ") bool"

	fmt.Fprintln(w, funcdef, "{")
	fmt.Fprintln(w, "	"+LOCK+".Lock()")
	fmt.Fprintln(w, "	defer "+LOCK+".Unlock()")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	for _, p := range x."+STRUCTVAR+" {")
	fmt.Fprintln(w, "		if p."+VARNAME+" == y."+VARNAME+" {")
	fmt.Fprintln(w, "			return false")
	fmt.Fprintln(w, "		}")
	fmt.Fprintln(w, "	}")
	fmt.Fprintln(w, "")
	fmt.Fprintln(w, "	x."+STRUCTVAR+" = append(x."+STRUCTVAR+", y)")
	fmt.Fprintln(w, "	return true")
	fmt.Fprintln(w, "}")
	fmt.Fprintln(w, "")

	return funcdef
}
